/*
	Panasonic camera firmware checksum tool
	Looks like it works on DMC G1 / GH1 firmwares
	It should probably work on the GF1 

	It justs remove checksum bytes, or add them
	Raphal Rigo - 2009

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#include <stdio.h>
#include <string.h>

unsigned short calc_csum(unsigned char *buf, int len)
{
	unsigned short csum, t;
	int i;

	csum = 0;
	for (i=0; i<len/2; i++) {
		t = (buf[i*2]<<8)| buf[i*2+1];
		t = (~t)+1;
		csum += t;
	}
	return csum;
}

int main(int argc, char *argv[])
{
	FILE *in, *out;
	int nread;
	unsigned char buf[34], ok[32];
	unsigned short csum, okcsum;
	char calc;


	if(argc < 4) {
		printf("args\n");
		return 1;
	}
	if (argv[1][0] == 'c') {
		printf("calculating checksums\n");
		calc = 1;
	} else {
		printf("verifying and removing checksums\n");
		calc = 0;
	}

	memset(ok, 0, 32);
	ok[0] = 0xFF;
	in = fopen(argv[2],"rb");
	out = fopen(argv[3],"wb+");

	if(!in || !out) {
		printf("error opening\n");
		return 1;
	}

	if (calc) {
		do {
			nread = fread(buf, 1, 32, in);
			if (nread) {
				csum = calc_csum(buf, 32);
				fwrite(buf, 1, nread, out);
				buf[0] = (csum>>8)&0xFF;
				buf[1] = csum&0xFF;
				fwrite(buf, 1, 2, out);
			}
		} while (nread && !feof(in));
	} else {
		do {
			nread = fread(buf, 1, 34, in);
			if (nread) {
				okcsum = ((buf[nread-2]<<8)|buf[nread-1]);
				csum = calc_csum(buf, 32);
				if (csum != okcsum ) {
					printf("checksum nok : %x %x \n", csum, okcsum);
				}
				fwrite(buf, 1, nread-2, out);
			}
		} while (nread && !feof(in));
	}
	fclose(in);
	fclose(out);

	return 0;
}
